/*
 * MINIGUI - Harbour Win32 GUI library
 *
*/

#include "minigui.ch"

Procedure Main
Local cExeName := GetExeFileName()
LOCAL cItem1, cItem3, i := 1

PRIVATE cCountry := cFilePath( cExeName ) + "\" + "Country.txt"
PRIVATE aCountries := GetCountryArray()

	DEFINE WINDOW Form_0 ;
		AT 0,0 ;
		WIDTH 500 ;
		HEIGHT 300 ;
		TITLE 'Tree Save Demo' ;
              	MAIN                 ;
                NOMAXIMIZE NOSIZE

			DEFINE TREE Tree_2 AT 10,10			;
				WIDTH 380 HEIGHT 242 			;
				VALUE 1					;
				TOOLTIP 'Double click for expand tree'	;
				NODEIMAGES { "close.bmp", "open.bmp" } 	;
				ITEMIMAGES { "close.bmp", "open.bmp" }

				WHILE i <= Len(aCountries)

					cItem1 := Token( aCountries[i], "#", 1 )

					NODE cItem1
						WHILE cItem1 = Token( aCountries[i], "#", 1 )

							cItem3 := Trim( Token( aCountries[i], "#", 2 ) ) + " [" + Token( aCountries[i], "#", 3 ) + "]"
							TREEITEM cItem3
							i++

							if i > Len(aCountries)
								exit
							endif
						END

					END NODE
				END

			END TREE

		@ 10, 405 BUTTON Button_1    ;
		  CAPTION 'Save' ;
                  WIDTH 70  ;
                  ACTION SaveTree('Country2.txt', aCountries)

		@ 50, 405 BUTTON Button_2 ;
		  CAPTION 'Exit' ;
                  WIDTH 70  ;
                  ACTION ThisWindow.Release

	END WINDOW

	CENTER WINDOW Form_0

	ACTIVATE WINDOW Form_0

Return

/////////////////////////////////////////////////////////////////////
*--------------------------------------------------------*
STATIC FUNCTION GetCountryArray()
*--------------------------------------------------------*
LOCAL aCountry := {}, cLine, oFile

	IF FILE( cCountry )

		oFile := TFileRead():New( cCountry )

		oFile:Open()

		IF oFile:Error()

			MsgStop( oFile:ErrorMsg( "FileRead: " ), "Error" )
		ELSE
			WHILE oFile:MoreToRead()
				cLine := oFile:ReadLine()
				IF SUBSTR(cLine, 1, 1) # "$" .AND. !EMPTY(SUBSTR(cLine, 1, 1)) .AND. AT(CHR(26), cLine) = 0
					AADD(aCountry, cLine)
				ENDIF
			END WHILE

			oFile:Close()
		ENDIF 
	ENDIF

RETURN ASORT(aCountry, , , {|a,b| UPPER(a) < UPPER(b)})

*--------------------------------------------------------*
Static Procedure SaveTree(cFileName, aTree)
*--------------------------------------------------------*
LOCAL cStrings := "", nCnt

	cStrings += "$   $ - symbol of comments in begin of string" + CRLF
	cStrings += "$   format of string" + CRLF
	cStrings += "$   country#capital#phone code" + CRLF + CRLF

	For nCnt := 1 To Len(aTree)
		IF !EMPTY(aTree[nCnt])
			cStrings += aTree[nCnt] + CRLF
		ENDIF
	Next

	hb_MemoWrit(cFileName, cStrings)

Return
